﻿
local auctionRunning = 0;
local itemRunning = nil;
local isInitiator = 0;
local theInitiator = "";
local specialSlot = 0;
local firstTimeThrough = 0;
local sessionMaster = 0;
local theVote = "";
local voteFor = "";
local suggestedBy = "";
local cmdDelim = " ";
local voteDelim = " ";
local selection = nil;
local cmdDelim = " ";
local voteDelim = " ";
local councilList = " ";
local councilNum = 1;
local MAX_ENTRIES = 25;
local MAX_VOTERS = 20;
local MAX_RAIDERS = 100;
local MAX_ENTRIES = 12;
local SCOPE_CHANNEL = "GUILD";

-------------- MainFrame_OnLoad --------------
-- Loads the Addon Frame
----------------------------------------------
function MainFrame_OnLoad()
    MainFrame:RegisterEvent("CHAT_MSG_OFFICER");
    MainFrame:RegisterEvent("CHAT_MSG_RAID");
    MainFrame:RegisterEvent("CHAT_MSG_GUILD");
    MainFrame:RegisterEvent("CHAT_MSG_ADDON");
    MainFrame:RegisterEvent("CHAT_MSG_WHISPER");
    MainFrame:SetScript("OnEvent", MainFrame_EventHandler);
    MainFrame:Hide();
	
	----------- Voting Reason Popup Box -----------
	-- Loads the voting reason box
	-----------------------------------------------
	StaticPopupDialogs["LOOT_COUNCIL_VOTE_REASON"] = {
		text = "Reason for voting %s?",
		button1 = ACCEPT,
		button2 = CANCEL,
		hasEditBox = 1,
		OnAccept = function(self)
			LootCouncil_Browser.updateVotes(UnitName("player"), voteFor, theVote, self.editBox:GetText())
		end,
		OnShow = function(self)
			self.editBox:SetFocus()
		end,
		EditBoxOnEnterPressed = function(self)
			LootCouncil_Browser.updateVotes(UnitName("player"), voteFor, theVote, self:GetText())
			self:GetParent():Hide()
		end,
		EditBoxOnEscapePressed = function(self)
			self:GetParent():Hide()
		end,
		timeout=0,
		whileDead  = 1,
		hideOnEscape = 1
	}
	
	StaticPopupDialogs["LOOT_COUNCIL_SUGGEST_ABORT"] = {
		text = "%s has suggested you abort this loot council session.",
		button1 = "Ignore",
		button2 = "Abort",
		OnAccept = function(self)
			suggestedBy = ""
			self:Hide()
		end,
		OnCancel = function(self)
			LootCouncil_Browser.confirmAbort()
		end,
		timeout=0,
		whileDead  = 1,
		hideOnEscape = 1
	}
	
	StaticPopupDialogs["LOOT_COUNCIL_CONFIRM_ABORT"] = {
		text = "Are you sure you want to end this loot council session?",
		button1 = "Yes",
		button2 = "No",
		OnAccept = function(self)
			LootCouncil_Browser.closeLootCouncilSession()
			self:Hide()
		end,
		timeout=0,
		whileDead  = 1,
		hideOnEscape = 1
	}

	----------- Create Table Entries -----------
	-- Creates the Table Entries
	--------------------------------------------
	local entry = CreateFrame("Button", "$parentEntry1", EntryFrame, "LootCouncil_Entry"); -- Creates the first entry
	entry:SetID(1); -- Sets its id
	entry:SetPoint("TOPLEFT", 4, -28) --Sets its anchor
	for ci = 2, MAX_ENTRIES do --Loops through to create more rows
		local entry = CreateFrame("Button", "$parentEntry"..ci, EntryFrame, "LootCouncil_Entry");
		entry:SetID(ci);
		entry:SetPoint("TOP", "$parentEntry"..(ci-1), "BOTTOM") -- sets the anchor to the row above
	end
	
	councilList = UnitName("player");
	councilNum = 1;
end


-------------- showMainFrame --------------
-- Shows the Main Frame
-------------------------------------------
function LootCouncil_Browser.showMainFrame()
	MainFrame:Show()
end


-------------- hideMainFrame --------------
-- Hides the Main Frame
-------------------------------------------
function LootCouncil_Browser.hideMainFrame()
	MainFrame:Hide()
end


--------- CloseButton_OnClick -------------
-- Closes the Main Frame
-------------------------------------------
function CloseButton_OnClick()
	LootCouncil_Browser.hideMainFrame();
end

-------------- MainFrame_EventHandler --------------
-- Event Handler for the Main Frame
-- EVENTS HANDLED: 
-- -- CHAT_MSG_OFFICER
-- -- CHAT_MSG_ADDON
-- -- CHAT_MSG_WHISPER
----------------------------------------------------
function MainFrame_EventHandler(self, event, ...)
	if event == "CHAT_MSG_OFFICER" and LootCouncil_LinkOfficer == 1 then
		local msg, sender = ...
		if isInitiator == 1 then
			LootCouncil_Browser.newEntry(sender, msg);
		end
	elseif event == "CHAT_MSG_WHISPER" and LootCouncil_LinkWhisper == 1 then
		local msg, sender = ...;
		if isInitiator == 1 and UnitName("player")~= sender then
			LootCouncil_Browser.newEntry(sender, msg);
		end
	elseif event == "CHAT_MSG_RAID" and LootCouncil_LinkRaid == 1 then
		local msg, sender = ...;
		if isInitiator == 1 then
			LootCouncil_Browser.newEntry(sender, msg);
		end
	elseif event == "CHAT_MSG_GUILD" and LootCouncil_LinkGuild == 1 then
		local msg, sender = ...;
		if isInitiator == 1 then
			LootCouncil_Browser.newEntry(sender, msg);
		end
	elseif event == "CHAT_MSG_ADDON" then
		local prefix, msg, channel, sender = ...
		if prefix == "L00TCOUNCIL" and sender ~= UnitName("player") then
			local cmd, other = strsplit(cmdDelim, msg, 2)
			if cmd == "start" then
				if other == nil or other == "" then
					print("FAILED TO START - Didn't get item link")
				else
					if (not itemRunning) or sender==theInitiator then
						local name, link = GetItemInfo(other);
						LootCouncil_Browser.heardStart(sender, other);
					else
						print("------------------------------------")
						print(""..sender.." tried to start a new consideration")
						print("but we already had one running!")
						print("------------------------------------")
					end
				end
			elseif cmd == "suggestAbort" then
				if suggestedBy then
					StaticPopup_Hide("LOOT_COUNCIL_SUGGEST_ABORT")
					StaticPopup_Show("LOOT_COUNCIL_SUGGEST_ABORT", sender)
				end
			elseif cmd == "abort" and sender==theInitiator then
				LootCouncil_Browser.closeLootCouncilSession()	
			elseif cmd == "vote" then
				local char, voter, vote, reason = strsplit(voteDelim, other, 4);
				LootCouncil_Browser.updateVotes(voter, char, vote, reason);
			elseif cmd == "end" then
				LootCouncil_Browser.resetConsideration();
			elseif cmd == "councilList" then
				CurrentCouncilList:SetText(other)
				CurrentCouncilList:Show()
				CurrentCouncilLabel:Show()
			elseif cmd == "echo" then
				LootCouncil_Browser.processEcho(sender, other);
			elseif cmd == "confirmed" then
				local private, single = strsplit(voteDelim, other, 2);
				LootCouncil_Browser.processResponse(tonumber(private), tonumber(single));
			elseif cmd == "itemEntry" then
				local name, item = strsplit(" ", other, 2);
				LootCouncil_Browser.recieveItemEntry(name, item);
			elseif cmd == "secondEntry" then
				local name, item = strsplit(" ", other, 2);
				LootCouncil_Browser.recieveSecondEntry(name, item);
			elseif cmd == "data" then
				LootCouncil_Browser.updatePlayerData(other);
			elseif cmd == "remove" and sender==theInitiator then
				LootCouncil_Browser.removePlayer(other)
			end
		end
	end
end


-------------- initiateLootCouncil --------------
-- Tries to initiate a new loot council session
-------------------------------------------------
function LootCouncil_Browser.initiateLootCouncil(item)
	if item == nil then
		print("Correct usage: /lc start (itemlink)")
	else
		if auctionRunning==1 and itemRunning then --If we have a consideration running, tell the user we can't start a new one
			print("Could not start a new consideration");
			print("Already running for "..itemRunning);
		else
			local isValid = LootCouncil_Browser.validInitiator("player");
			if isValid == 0 then -- Fires when player is IN a raid but NOT a raid officer
				print("You cannot start a new Loot Council Session.");
				print("You must be a Raid Assistant to start a new Loot Council Session");
			elseif isValid == 3 then -- Fires when player is NOT in a raid and is NOT the guild leader
				print("You cannot start a new Loot Council Session.");
				print("You must be in a Raid or the Guild Leader to start a new Loot Council Session");
			elseif isValid == 1 then -- Fires when player is either a raid officer or guild leader
				LootCouncil_Browser.WhisperList = {}
				itemRunning = item; -- Set the current item that's running
				isInitiator=1; -- We're the initiator, so set that
				theInitiator = UnitName("player");
				--Send out the messages regarding the item
				SendChatMessage("--------------STARTED--------------", "OFFICER"); 
				SendChatMessage("item: "..itemRunning, "OFFICER");
				local found, _, itemString = string.find(itemRunning, "^|c%x+|H(.+)|h%[.*%]")
				SendAddonMessage("L00TCOUNCIL", "start"..cmdDelim..itemString, "GUILD");
				firstTimeThrough = 0;
				CurrentCouncilList:SetText(councilList)
				CurrentCouncilList:Show()
				CurrentCouncilLabel:Show()
				LootCouncil_Browser.showMainFrame();
				councilList = UnitName("player");
				councilNum = 1;
				if UnitInRaid("player") then
					SendChatMessage(""..itemRunning.." now under consideration!", "RAID_WARNING");
					SendChatMessage("If you want "..itemRunning..", link your current item in the appropriate channel.", "RAID");
				else
					SendChatMessage(""..itemRunning.." now under consideration!", "GUILD");
					SendChatMessage("If you want "..itemRunning..", link your current item in the appropriate channel.", "GUILD");
				end
				
				LootCouncil_Browser.prepareLootFrame();
			end
		end
	end
end


-------------- validInitiator ---------------------------
-- Checks if the client or sender is able to initiate a new session
---------------------------------------------------------
function LootCouncil_Browser.validInitiator(sender)
	if sender == "player" then
		if UnitInRaid("player") then -- If the player is in a raid
			if IsRaidOfficer() then
				return 1
			else
				return 0
			end
		else
			if IsGuildLeader(UnitName("player")) == 1 then -- If they're the guild leader
				return 1; --Then return 1
			else
				return 3; -- Else, return 3
			end
		end
	else
		for ci = 1, GetNumGuildMembers() do
			local name, rank, rankIndex, level, class, zone, note, officernote, online, status, classFileName = GetGuildRosterInfo(ci);
			if name == sender then
				if rankIndex <= LootCouncil_minRank then
					return 1;
				else
					return 0;
				end
			end
		end
	end
end


-------------- prepareLootFrame -------------------------
-- Prepares the main frame for such
---------------------------------------------------------
function LootCouncil_Browser.prepareLootFrame()
	auctionRunning=1; -- We're running an auction now, so set it to true;
	local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount, thisItemEquipLoc, thisItemTexture = GetItemInfo(itemRunning); -- Get the item info
	CurrentItemTexture:SetTexture(thisItemTexture); -- Set the texture of the icon box
	CurrentItemTexture:Show(); -- Open up the icon box
	AbortButton:Show(); -- Show the Abort Button
	CurrentItemLvl:SetText(iLevel); -- Show the Item Level
	CurrentItemLink:SetText(sLink); -- Set the item link for color and such
	CurrentItemLevelLabel:Show(); -- Show the Lable for item leve
	EmptyTexture:Hide(); -- Hide the empty texture
	LootCouncil_Browser.Elects = {} -- Reset all entrants
	LootCouncil_Browser.Votes = {} -- Reset all votes
	RemoveButton:Hide()
	local slotNum = LootCouncil_Browser.translateToSlot(thisItemEquipLoc);
	if slotNum == 13 or slotNum == 11 or slotNum == 16 then
		specialSlot = 1;
	else
		specialSlot = 0;
	end
	CurrentItemHover:Show()
	for ci = 1, MAX_ENTRIES do
		if LootCouncil_Browser.single == 1 then
			getglobal("EntryFrameEntry"..ci.."AgainstButton"):Hide()
		else
			getglobal("EntryFrameEntry"..ci.."AgainstButton"):Show()
		end
		
		if LootCouncil_Browser.private == 1 then
			getglobal("EntryFrameEntry"..ci.."VoteHover1"):Hide()
		else
			getglobal("EntryFrameEntry"..ci.."VoteHover1"):Show()
		end	
	end
	if LootCouncil_Browser.single == 1 then
		getglobal("EntryFrameHeaderVotesTotal"):SetText("Total Votes")
	else
		getglobal("EntryFrameHeaderVotesTotal"):SetText("Total Votes (+/-)")
	end
end


-------------- heardStart ---------------------
-- Process a "start" command
-----------------------------------------------
function LootCouncil_Browser.heardStart(sender, item)
	councilList = "";
	councilNum = 0;
	if (LootCouncil_Browser.validInitiator(sender) == 1) then
		theInitiator = sender;
		isInitiator = 0; -- We're NOT the initiator
		local rprsName, rprsLink = GetItemInfo(item); -- Get the item link (since we just got sent the item string)
		itemRunning = rprsLink;
		SendAddonMessage("L00TCOUNCIL", "echo "..LootCouncil_Version, "WHISPER", theInitiator);
	else
		print(sender.." tried to join a new loot council session but the initiator had insufficient privelages.");
	end
end


-------------- processEcho ---------------------
-- Process an echo to add to the loot list
-----------------------------------------------
function LootCouncil_Browser.processEcho(sender, ver)
	if isInitiator == 1 then
		if LootCouncil_Version == ver then
			for ci = 1, GetNumGuildMembers() do
				local name, rank, rankIndex, level, class, zone, note, officernote, online, status, classFileName = GetGuildRosterInfo(ci);
				if name == sender then
					if (rankIndex+1) <= LootCouncil_minRank then
						table.insert(LootCouncil_Browser.WhisperList, sender)
						councilList = councilList..", "..sender
						councilNum = councilNum + 1
						CurrentCouncilList:SetText(councilList)
						LootCouncil_Browser.sendGlobalMessage("councilList "..councilList)
						SendAddonMessage("L00TCOUNCIL", "confirmed "..LootCouncil_privateVoting.." "..LootCouncil_singleVote, "WHISPER", sender);
						break;
					end
				end
			end
		else
			if (not ver) or tonumber(LootCouncil_Version) > tonumber(ver) then
				SendChatMessage("YOUR LOOT COUNCIL VERSION IS OUTDATED. Please upgrade to version "..LootCouncil_Version.." to be on the council.", "WHISPER", nil, sender)
			else
				print("YOUR LOOT COUNCIL VERSION IS OUTDATED. Please upgrade to version "..ver"!!!")
			end
		end
	end
end


-------------- processResponse-----------------
-- Processes the response to an echo to prepare
-- the Main Frame
-----------------------------------------------
function LootCouncil_Browser.processResponse(prv, sing)
	LootCouncil_Browser.private = prv;
	LootCouncil_Browser.single = sing;
	firstTimeThrough = 1;
	LootCouncil_Browser.prepareLootFrame()
	MainFrame:Show()
end


-------------- resetConsideration -------------
-- Ends the Loot Council Session
-----------------------------------------------
function LootCouncil_Browser.resetConsideration()
	RemoveButton:Hide()
	LootCouncil_Browser.ClearSelection()
	sessionMaster = 0;
	EmptyTexture:Show();
	CurrentItemTexture:Hide();
	itemRunning = nil;
	auctionRunning = 0;
	LootCouncil_Browser.Elects = {}
	LootCouncil_Browser.Update();
	CurrentItemLevelLabel:Hide();
	AbortButton:Hide();
	CurrentItemLvl:SetText("");
	EmptyTexture:Show();
	CurrentItemLink:SetText("");
	CurrentItemTexture:Hide();
	CurrentCouncilList:SetText("")
	CurrentCouncilList:Hide()
	CurrentCouncilLabel:Hide()
	CurrentItemHover:Hide()
	VotesForLabel:Hide()
	VotesFor:Hide()
	VotesAgainstLabel:Hide()
	VotesAgainst:Hide();
	LootCouncil_Browser.Update();
	LootCouncil_Browser.private = LootCouncil_privateVoting;
	LootCouncil_Browser.single = LootCouncil_singleVote;
end


-------------- alreadyLinkedItem --------------
-- Checks if the user has already linked an item
-- If they have, then update it
-----------------------------------------------
function LootCouncil_Browser.alreadyLinkedItem(name, item)
	for ci = 1, MAX_ENTRIES do
		local entry = LootCouncil_Browser.Elects[ci];
		if entry and entry[1] and entry[1] == name then
			local psName, psLink, piRarity, piLevel, piMinLevel, psType, psSubType, piStackCount, pthisItemEquipLoc = GetItemInfo(item);
			entry[2] = item.." ("..piLevel..")";
			entry[3] = piLevel
			entry[12] = 1;
			entry[13] = psLink;
			entry[14] = nil;
			LootCouncil_Browser.Update()
			return ci;
		end
	end
	return 0
end


---------- ShowCurrentItemTooltip -------------
-- Shows item that's under the running Tooltip
-----------------------------------------------
function LootCouncil_Browser.ShowCurrentItemTooltip()
	if itemRunning then
		GameTooltip:SetOwner(MainFrame, "ANCHOR_CURSOR")
		GameTooltip:SetHyperlink(itemRunning)
		GameTooltip:Show()
	end
end


---------- ShowCurrentSelectionTooltip -------------
-- Shows item that's under the running Tooltip
-----------------------------------------------
function LootCouncil_Browser.ShowCurrentSelectionTooltip()
	if selection then
		GameTooltip:SetOwner(MainFrame, "ANCHOR_CURSOR")
		GameTooltip:SetHyperlink(selection[13])
		GameTooltip:Show()
	end
end

---------- ShowCurrentSelectionDualTooltip -------------
-- Shows item that's under the running Tooltip
-----------------------------------------------
function LootCouncil_Browser.ShowCurrentSelectionDualTooltip()
	if selection then
		GameTooltip:SetOwner(MainFrame, "ANCHOR_CURSOR")
		GameTooltip:SetHyperlink(selection[14])
		GameTooltip:Show()
	end
end


------------------ CastVote -------------------
-- Maintains the Cast Vote Buttons
-----------------------------------------------
function LootCouncil_Browser.CastVote(id, vote, click)
	local entry = LootCouncil_Browser.Elects[id];
	if entry and entry[9]~= vote then
		if vote == "None" then
			LootCouncil_Browser.updateVotes(UnitName("player"), entry[1], vote, "");
		else
			theVote = vote;
			voteFor = entry[1];
			if click == "LeftButton" then
				LootCouncil_Browser.updateVotes(UnitName("player"), voteFor, theVote, "No Reason")
			elseif click == "RightButton" and LootCouncil_Browser.private == 0 then
				StaticPopup_Show("LOOT_COUNCIL_VOTE_REASON", ""..string.upper(theVote).." "..voteFor)
			end
		end
	end
end


------------------ newEntry -------------------
-- Adds a new entry
-----------------------------------------------
function LootCouncil_Browser.newEntry(name, msg) --Add a new entry to the loot table
	if auctionRunning==1 and itemRunning and name and msg ~= nil and isInitiator == 1 then -- Make sure we have an auction running
		local theItem = msg:find("|Hitem:"); -- See if they linked an item
		if theItem and theItem >= 0 then -- If they entered a valid item
			if firstTimeThrough == 0 and name==UnitName("player") then -- (Initial Link by the raid leader)
				firstTimeThrough = 1 -- Throw the switch
			else
				local actualItemString2; -- Initialize for possibility of 2 item links
				local startLoc = string.find(msg, "Hitem:") -- Make sure they linked an item
				local endLoc = string.find(msg, "|", startLoc)
				local actualItemString = string.sub(msg, startLoc, endLoc) -- Isolate the item string
				if (specialSlot == 1) then -- If this was a trinket/weapon/rings
					theItem = msg:find("|Hitem:", endLoc) --See if they linked a second item
					if theItem and theItem >= 0 then -- If they did
						local startLoc = string.find(msg, "Hitem:", endLoc) -- Isolate the item string
						local endLoc = string.find(msg, "|", startLoc)
						actualItemString2 = string.sub(msg, startLoc, endLoc)
					end
				end
				local psName, psLink, piRarity, piLevel, piMinLevel, psType, psSubType, piStackCount, pthisItemEquipLoc = GetItemInfo(actualItemString); -- Get better info for item 1
				local psName2, psLink2, piRarity2, piLevel2, piMinLevel2, psType2, psSubType2, piStackCount2, pthisItemEquipLoc2; -- Initialize scoping for second variable.
				if actualItemString2 and (specialSlot == 1) then -- If they linked a second item and it was appropriate
					psName2, psLink2, piRarity2, piLevel2, piMinLevel2, psType2, psSubType2, piStackCount2, pthisItemEquipLoc2 = GetItemInfo(actualItemString2); --Initialize those variables
				end
				local actualItem = msg;
				local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount, thisItemEquipLoc = GetItemInfo(itemRunning); --Get the current info
				-- If this item has no equip loc OR the two items they linked have the same equip loc AND there either is no second item or the second item has the same equip loc
				if ((thisItemEquipLoc == "") or (LootCouncil_Browser.translateToSlot(pthisItemEquipLoc) == LootCouncil_Browser.translateToSlot(thisItemEquipLoc)) and ((not pthisItemEquipLoc2) or (LootCouncil_Browser.translateToSlot(pthisItemEquipLoc2) == LootCouncil_Browser.translateToSlot(thisItemEquipLoc)))) then 
					local indexOfPlayer = LootCouncil_Browser.alreadyLinkedItem(name, psLink);
					if indexOfPlayer > 0 then -- Check to see if they've already linked an item
						if pthisItemEquipLoc2 then -- If they have already linked an item, we already updated the first item, so we need to update the second
							theEntry = LootCouncil_Browser.Elects[indexOfPlayer]; -- Get their index
							if indexOfPlayer > 0 and LootCouncil_Browser.IsSelected(indexOfPlayer) then
								LootCouncil_Browser.SelectEntry(indexOfPlayer)
							end
							theEntry[2] = theEntry[2].."\n"..psLink2.." ("..piLevel2..")"; -- append the second item link
							theEntry[3] = piLevel.." - "..piLevel2
							theEntry[12] = 2; -- switch the flag
							theEntry[14] = psLink2; -- hold the second link
							SendChatMessage("Recieved update in consideration for " .. itemRunning, "WHISPER", nil, name);
							SendChatMessage("Your current items: "..theEntry[13].." - "..theEntry[14], "WHISPER", nil, name);
								-- Send a message
							LootCouncil_Browser.sendGlobalMessage("itemEntry "..name.." "..actualItemString) -- Send out info to other council
							LootCouncil_Browser.sendGlobalMessage("secondEntry "..name.." "..actualItemString2)
						else -- Else they only have 1 item
							if indexOfPlayer > 0 and LootCouncil_Browser.IsSelected(indexOfPlayer) then
								LootCouncil_Browser.SelectEntry(indexOfPlayer)
							end
							SendChatMessage("Recieved update in consideration for " .. itemRunning .. " - Your current item: "..actualItem, "WHISPER", nil, name);
							LootCouncil_Browser.sendGlobalMessage("itemEntry "..name.." "..actualItemString)
						end
						LootCouncil_Browser.Update();
						if indexOfPlayer > 0 and LootCouncil_Browser.IsSelected(indexOfPlayer) then
							LootCouncil_Browser.SelectEntry(indexOfPlayer)
						end
					else -- They haven't already linked an item
						SendChatMessage("You are now being considered for "..itemRunning, "WHISPER", nil, name); -- Whisper them about their consideration
						LootCouncil_Browser.sendGlobalMessage("itemEntry "..name.." "..actualItemString) -- Send out a global message
						if psLink2 and (specialSlot == 1) then -- If this is a 2-item slot and they linked 2 items
							SendChatMessage("Your current items: "..psLink.." - "..psLink2, "WHISPER", nil, name); -- Send them about BOTH items
							LootCouncil_Browser.sendGlobalMessage("secondEntry "..name.." "..actualItemString2) -- Alert other councilmen about the second entry
							table.insert(LootCouncil_Browser.Elects, { -- put them in the table
								name, -- Player Name
								psLink.." ("..piLevel..")\n"..psLink2.." ("..piLevel2..")",
								piLevel.." - "..piLevel2, -- Item Level of Item they linked
								"-", -- Attendance
								"-", -- Item Density
								"-", -- Last Item
								0, -- Number of Votes For
								0, -- Number of Votes Against
								"None", -- Initialize "No Vote"
								{},
								LootCouncil_Browser.getGuildRank(name),
								2,
								psLink,
								psLink2
							})
						else -- Else they only linked 1 item or this isn't a special slot
							SendChatMessage("Your current item: "..actualItem, "WHISPER", nil, name);
							table.insert(LootCouncil_Browser.Elects, {
								name, -- Player Name
								psLink.." ("..piLevel..")",
								piLevel, -- Item Level of Item they linked
								"-", -- Attendance
								"-", -- Item Density
								"-", -- Last Item
								0, -- Number of Votes For
								0, -- Number of Votes Against
								"None", -- Initialize "No Vote"
								{},
								LootCouncil_Browser.getGuildRank(name),
								1,
								psLink,
								nil
							})
						end


						LootCouncil_Browser.Update();
					end
				else
					SendChatMessage("ERROR!!! You linked an INVALID SLOT and are not in the consideration yet for "..itemRunning..". Please re-link!", "WHISPER", nil, name);
				end
			end
		end
	end
end

function LootCouncil_Browser.recieveItemEntry(name, itemString)
	if auctionRunning==1 and itemRunning and name and itemString and isInitiator == 0 then -- Make sure we have an auction running
		local psName, psLink, piRarity, piLevel, piMinLevel, psType, psSubType, piStackCount, pthisItemEquipLoc = GetItemInfo(itemString); -- Get better info
		local indexOfPlayer = LootCouncil_Browser.alreadyLinkedItem(name, psLink)
		if indexOfPlayer > 0 and LootCouncil_Browser.IsSelected(indexOfPlayer) then
			LootCouncil_Browser.SelectEntry(indexOfPlayer)
		end
		if  indexOfPlayer == 0 then -- If we didn't find them in the table
			table.insert(LootCouncil_Browser.Elects, {
				name, -- Player Name
				psLink.." ("..piLevel..")",
				piLevel, -- Item Level of Item they linked
				"-", -- Attendance
				"-", -- Item Density
				"-", -- Last Item
				0, -- Number of Votes For
				0, -- Number of Votes Against
				"None", -- Initialize "No Vote"
				{},
				LootCouncil_Browser.getGuildRank(name),
				1,
				psLink,
				nil
			})
			LootCouncil_Browser.Update();
		end
	end
end

function LootCouncil_Browser.recieveSecondEntry(name, itemString)
	if auctionRunning==1 and itemRunning and name and itemString and isInitiator == 0 then -- Make sure we have an auction running
		local psName, psLink, piRarity, piLevel, piMinLevel, psType, psSubType, piStackCount, pthisItemEquipLoc = GetItemInfo(itemString); -- Get better info
		for ci=1, MAX_ENTRIES do -- It's the second item, so they SHOULD be in the table
			theEntry = LootCouncil_Browser.Elects[ci];
			if theEntry and theEntry[1]==name then
				theEntry[2] = theEntry[2].."\n"..psLink.." ("..piLevel..")";
				theEntry[3] = theEntry[3].." - "..piLevel;
				theEntry[12] = 2;
				theEntry[14] = itemString
				if LootCouncil_Browser.IsSelected(ci) then
					LootCouncil_Browser.updateVoteSelectionText()
				end
			end
		end
		LootCouncil_Browser.Update();
	end
end

function LootCouncil_Browser.updatePlayerData(other)
	local name, attendance, density, lastItem = strsplit(" ", other, 4)
	theRest = more;
	if LootCouncil_Browser.playerInData(name, attendance, density, lastItem) == 0 then
		table.insert(LootCouncil_Browser.Data, {
			name,
			"-",
			"-",
			"-"
		})
	end
	LootCouncil_Browser.Update()
end

function LootCouncil_Browser.Update()
	for ci = 1, MAX_ENTRIES do
		local entry = LootCouncil_Browser.Elects[ci]
		local frame = getglobal("EntryFrameEntry"..ci)
		if entry and frame then
			if entry[12] == 2 then
				getglobal(frame:GetName().."ItemFrame2"):Show()
			else
				getglobal(frame:GetName().."ItemFrame2"):Hide()
			end
			frame:Show()
			getglobal(frame:GetName().."CharName"):SetText(entry[1])
			getglobal(frame:GetName().."Item"):SetText(entry[2])
			getglobal(frame:GetName().."Itemlvl"):SetText(entry[11])
			if (LootCouncil_Browser.single == 0) then
				getglobal(frame:GetName().."VotesTotal"):SetText("     "..entry[7].." / "..entry[8].."             ( "..(entry[7]-entry[8]).." ) ")
			else
				getglobal(frame:GetName().."VotesTotal"):SetText(""..entry[7])
			end
			getglobal(frame:GetName().."YourVote"):SetText(entry[9])
			if entry.isSelected then
				getglobal(frame:GetName().."BG"):Show()
			else
				getglobal(frame:GetName().."BG"):Hide()
			end
		else
			frame:Hide()
		end
	end
end

function LootCouncil_Browser.SelectEntry(id)
	if selection then
		for ci = 1, MAX_ENTRIES do
			getglobal("EntryFrameEntry"..ci .."BG"):Hide()
		end
		selection.isSelected = nil
	end
	selection = LootCouncil_Browser.Elects[id]
	selection.isSelected = true;
	if selection then
		local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount, thisItemEquipLoc, thisItemTexture;
		local sName2, sLink2, iRarity2, iLevel2, iMinLevel2, sType2, sSubType2, iStackCount2, thisItemEquipLoc2, thisItemTexture2;
		if selection[13] then
			sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount, thisItemEquipLoc, thisItemTexture = GetItemInfo(selection[13]);
		end
		
		if isInitiator == 1 then
			RemoveButton:Show()
		else
			RemoveButton:Hide()
		end
		CurrentSelectionLabel:Show()
		CurrentSelectionName:SetText(selection[1])
		CurrentSelectionName:Show()
		if selection[12] == 1 then

			
			CurrentSelectionLink:SetText(selection[2])
			CurrentSelectionLink:Show()
			if thisItemTexture then
				CurrentSelectionTexture:SetTexture(thisItemTexture);
			end
	-- LOOK HERE		
			
			ClearSelectionButton:Show()
			
			CurrentSelectionTexture:Show()
			CurrentSelectionHover:Show()
			
			DualItemTexture1:Hide();
			DualItemTexture2:Hide();
			DualItem1:Hide()
			DualItem2:Hide()
			CurrentSelectionHover2:Hide();
		elseif selection[12] == 2 then
			sName2, sLink2, iRarity2, iLevel2, iMinLevel2, sType2, sSubType2, iStackCount2, thisItemEquipLoc2, thisItemTexture2 = GetItemInfo(selection[14]);
			CurrentSelectionLink:Hide()
			DualItemTexture1:SetTexture(thisItemTexture);
			DualItemTexture2:SetTexture(thisItemTexture2);
			DualItemTexture1:Show();
			DualItemTexture2:Show();
			CurrentSelectionHover:Show()
			CurrentSelectionHover2:Show()
			DualItem1:SetText(sLink.." ("..iLevel..")")
			DualItem2:SetText(sLink2.." ("..iLevel2..")")
			DualItem2:Show()
			DualItem1:Show()
			CurrentSelectionTexture:Hide()
		end
			ClearSelectionButton:Show()
		if LootCouncil_Browser.private == 0 then
			VotesForLabel:Show()
			VotesFor:Show()
			VotesAgainstLabel:Show()
			VotesAgainst:Show()
		end
		LootCouncil_Browser.Update()
		LootCouncil_Browser.updateVoteSelectionText()
		
	else
		LootCouncil_Browser.ClearSelection()
	end
end

function LootCouncil_Browser.updateVoteSelectionText()
	if LootCouncil_Browser.private == 0 then
		local absoluteVotesFor = "";
		local absoluteVotesAgainst = "";
		local forIndex = 1;
		local againstIndex = 1;
		local theVotes = selection[10];
		for ci = 1, MAX_VOTERS do
			local singularVoter = theVotes[ci]
			if singularVoter then
				if singularVoter[2] == "For" then
					if forIndex > 1 then
						absoluteVotesFor = ""..absoluteVotesFor..", "
					end
					absoluteVotesFor = absoluteVotesFor..""..singularVoter[1];
					if singularVoter[3] ~= "No Reason" then
						absoluteVotesFor = absoluteVotesFor.." ("..singularVoter[3]..")";
					end
					forIndex = forIndex+1
				elseif singularVoter[2] == "Against" then
					if againstIndex > 1 then
						absoluteVotesAgainst = ""..absoluteVotesAgainst..", "
					end
					absoluteVotesAgainst = absoluteVotesAgainst..""..singularVoter[1];
					if singularVoter[3] ~= "No Reason" then
						absoluteVotesAgainst = absoluteVotesAgainst.." ("..singularVoter[3]..")";
					end
					againstIndex = againstIndex+1
				end
			end
		end
		
		if forIndex > 1 then
			VotesFor:SetText(absoluteVotesFor)
		else
			VotesFor:SetText("No votes for")
		end
		
		if againstIndex > 1 then
			VotesAgainst:SetText(absoluteVotesAgainst)
		else
			VotesAgainst:SetText("No votes against")
		end
	end
end

function LootCouncil_Browser.ClearSelection()
	if selection then
		for ci = 1, MAX_ENTRIES do
			getglobal("EntryFrameEntry"..ci .."BG"):Hide()
		end
		selection.isSelected = nil
	end
	selection = nil;
	RemoveButton:Hide()
	ClearSelectionButton:Hide()
	CurrentSelectionLink:Hide()
	CurrentSelectionTexture:Hide()
	CurrentSelectionHover:Hide()
	CurrentSelectionLabel:Hide()
	CurrentSelectionName:Hide()
	CurrentSelectionItemLevelLabel:Hide()
	CurrentSelectionItemLevel:Hide()
	VotesForLabel:Hide()
	VotesFor:Hide()
	VotesAgainstLabel:Hide()
	VotesAgainst:Hide()
end

function LootCouncil_Browser.IsSelected(id)
	return LootCouncil_Browser.Elects[id] == selection
end

function LootCouncil_Browser.toolMouseOver(id)
	local entry = LootCouncil_Browser.Elects[id];
	if entry then
		GameTooltip:SetOwner(MainFrame, "ANCHOR_CURSOR")
		GameTooltip:SetHyperlink(entry[13])
		GameTooltip:Show()
	end
end

function LootCouncil_Browser.toolMouseOverDual(id)
	local entry = LootCouncil_Browser.Elects[id];
	if entry then
		if entry[12] == 2 then
			GameTooltip:SetOwner(MainFrame, "ANCHOR_CURSOR")
			GameTooltip:SetHyperlink(entry[14])
			GameTooltip:Show()
		end
	end
end

function LootCouncil_Browser.toolMouseLeave()
	GameTooltip:Hide()
end

function LootCouncil_Browser.updateVotes(sender, char, vote, reason)
	if isInitiator == 0 then -- If we are NOT the initiator
		if sender == UnitName("player") then -- Check if we're casting the vote
			-- If we are, send it to the initiator
			SendAddonMessage("L00TCOUNCIL", "vote"..cmdDelim..char..voteDelim..UnitName("player")..voteDelim..vote..voteDelim..reason, "WHISPER", theInitiator);
		end
	elseif LootCouncil_Browser.isValidVoter(sender) == 1 then
		-- Otherwise, we are the initiator, so we need to send it to everyone EXCEPT the person who cast it
		LootCouncil_Browser.sendGlobalMessage("vote"..cmdDelim..char..voteDelim..sender..voteDelim..vote..voteDelim..reason, sender);
	end
	if LootCouncil_Browser.isValidVoter(sender) == 1 then
		if LootCouncil_Browser.single == 0 then
			for ci = 1, MAX_ENTRIES do -- Loop through all people on the table
				local theEntry = LootCouncil_Browser.Elects[ci]; -- Pull each row
				if theEntry and theEntry[1] and theEntry[1] == char then -- If the row has data in it and it's the character that was voted for
					if sender == UnitName("player") then -- If it's our vote, then update it on the table
						theEntry[9] = vote;
					end
					local theVotes = theEntry[10] -- Get the current votes
					local found = 0; -- Initialize helper variable
					for ki = 1, MAX_VOTERS do -- Loop through all the potential voters
						if theVotes[ki] then -- If this voter exists
							local singularVoter = theVotes[ki] -- get the individual voter
							if singularVoter and singularVoter[1] == sender then -- check To see if it's the person who cast their vote
								if found > 0 then -- if we've found this person twice, then there's a problem...
									print("HIGHLY LIKELY AN ERROR OCCURED. END CONSIDERATION AND RESTART VOTING")
								else
									found = ki --Update helper variable
								end
							end
						end
					end
					
					
					
					if found == 0 then -- if we didn't find anyone, then they're probably not in the table yet!
						table.insert(theEntry[10], { -- So add them
							sender,
							vote,
							reason
						})
					else -- Otherwise, we did find them
						if vote == "None" then -- If they voted none, take them out of the table
							table.remove(theVotes, ki)
						else -- Otherwise, update their vote
							local singularVoter = theVotes[found]
							singularVoter[2] = vote;
							singularVoter[3] = reason;
						end
					end
					local numFor = 0; -- Count how many are FOR this voter
					local numAgainst = 0; -- Count how many are AGAINST this voter
					for ki = 1, MAX_VOTERS do -- Loop through all the potential voters
						if theVotes[ki] then -- If this voter exists
							local singularVoter = theVotes[ki] -- Get the individual voter
							if singularVoter and singularVoter[2] == "For" then -- Add one if he's for
								numFor = numFor +1;
							elseif singularVoter and singularVoter[2] == "Against" then -- Add one if he's against
								numAgainst = numAgainst + 1;
							end
						end
					end
					theEntry[7] = numFor;
					theEntry[8] = numAgainst;
					if theEntry == selection then -- If this is our current selection
						LootCouncil_Browser.updateVoteSelectionText() -- Then update the text on the table.
					end
				end
			end
		else
			for ci = 1, MAX_ENTRIES do -- Loop through all people on the table
				local theEntry = LootCouncil_Browser.Elects[ci]; -- Pull each row
				if theEntry then
					local theVotes = theEntry[10];
					for ki = 1, MAX_VOTERS do
						if theVotes[ki] then
							local singularVoter = theVotes[ki];
							if singularVoter and singularVoter[1] == sender then
								theVotes[ki] = nil;
								theEntry[9] = "None";
							end
						end
					end
					
					if vote ~= "None" and theEntry[1] == char then
						table.insert(theEntry[10], { -- So add them
							sender,
							vote,
							reason
						})
					end
					if sender == UnitName("player") and theEntry[1] == char then
						theEntry[9] = vote;
					end
						
					
					local numFor = 0; -- Count how many are FOR this voter
					local numAgainst = 0; -- Count how many are AGAINST this voter
					for ki = 1, MAX_VOTERS do -- Loop through all the potential voters
						if theVotes[ki] then -- If this voter exists
							local singularVoter = theVotes[ki] -- Get the individual voter
							if singularVoter and singularVoter[2] == "For" then -- Add one if he's for
								numFor = numFor +1;
							elseif singularVoter and singularVoter[2] == "Against" then -- Add one if he's against
								numAgainst = numAgainst + 1;
							end
						end
					end
					theEntry[7] = numFor;
					theEntry[8] = numAgainst;
					if theEntry == selection then -- If this is our current selection
						LootCouncil_Browser.updateVoteSelectionText() -- Then update the text on the table.
					end
				end
			end
		end			
		LootCouncil_Browser.Update()
	end

end

function LootCouncil_Browser.voteToolActivate(id)
	local entry = LootCouncil_Browser.Elects[id];
	local votesFor = {};
	local votesAgainst = {}
	local forIndex = 1;
	local againstIndex = 1;
	if entry then
		GameTooltip:SetOwner(MainFrame, "ANCHOR_CURSOR")
		local theVotes = entry[10];
		for ci = 1, MAX_VOTERS do
			local singularVoter = theVotes[ci]
			if singularVoter then
				if singularVoter[2] == "For" then
					votesFor[forIndex] = ""..singularVoter[1]..": "..singularVoter[3];
					forIndex = forIndex+1
				elseif singularVoter[2] == "Against" then
					votesAgainst[againstIndex] = ""..singularVoter[1]..": "..singularVoter[3];
					againstIndex = againstIndex+1
				end
			end
		end
		if forIndex > 1 then
			GameTooltip:AddLine("Votes For:", 1, 1, 1, 1);
			for ci=1,(forIndex-1) do
				GameTooltip:AddLine(votesFor[ci], 1, 1, 1, 1);
			end
			GameTooltip:AddLine(" ", 1, 1, 1, 1);
		end
		
		if againstIndex > 1 then
			GameTooltip:AddLine("Votes Against:", 1, 1, 1, 1);
			for ci=1,(againstIndex-1) do
				GameTooltip:AddLine(votesAgainst[ci], 1, 1, 1, 1);
			end
		end
		
		if forIndex >1 or againstIndex>1 then
			GameTooltip:Show()
		end
	end
end

function LootCouncil_Browser.sendGlobalMessage(msg)
	for ci = 1, MAX_VOTERS do
		if LootCouncil_Browser.WhisperList[ci] then
			SendAddonMessage("L00TCOUNCIL", msg, "WHISPER", LootCouncil_Browser.WhisperList[ci])
		end
	end
end

function LootCouncil_Browser.sendGlobalMessage(msg, sender)
	for ci = 1, MAX_VOTERS do
		if LootCouncil_Browser.WhisperList[ci] and LootCouncil_Browser.WhisperList[ci]~= sender then
			SendAddonMessage("L00TCOUNCIL", msg, "WHISPER", LootCouncil_Browser.WhisperList[ci])
		end
	end
end

function LootCouncil_Browser.translateToSlot(itemEquipLoc)
	if itemEquipLoc == "" then return 0
	elseif itemEquipLoc == "INVTYPE_AMMO" then return 0
	elseif itemEquipLoc == "INVTYPE_HEAD" then return 1
	elseif itemEquipLoc == "INVTYPE_NECK" then return 2
	elseif itemEquipLoc == "INVTYPE_SHOULDER" then return 3
	elseif itemEquipLoc == "INVTYPE_BODY" then return 4
	elseif itemEquipLoc == "INVTYPE_CHEST" then return 5
	elseif itemEquipLoc == "INVTYPE_ROBE" then return 5
	elseif itemEquipLoc == "INVTYPE_WAIST" then return 6
	elseif itemEquipLoc == "INVTYPE_LEGS" then return 7
	elseif itemEquipLoc == "INVTYPE_FEET" then return 8
	elseif itemEquipLoc == "INVTYPE_WRIST" then return 9
	elseif itemEquipLoc == "INVTYPE_HAND" then return 10
	elseif itemEquipLoc == "INVTYPE_FINGER" then return 11
	elseif itemEquipLoc == "INVTYPE_TRINKET" then return 13
	elseif itemEquipLoc == "INVTYPE_CLOAK" then return 15
	elseif itemEquipLoc == "INVTYPE_WEAPON" then return 16
	elseif itemEquipLoc == "INVTYPE_SHIELD" then return 16
	elseif itemEquipLoc == "INVTYPE_2HWEAPON" then return 16
	elseif itemEquipLoc == "INVTYPE_WEAPONMAINHAND" then return 16
	elseif itemEquipLoc == "INVTYPE_WEAPONOFFHAND" then return 16
	elseif itemEquipLoc == "INVTYPE_HOLDABLE" then return 16
	elseif itemEquipLoc == "INVTYPE_RANGED" then return 18
	elseif itemEquipLoc == "INVTYPE_THROWN" then return 18
	elseif itemEquipLoc == "INVTYPE_RANGEDRIGHT"  then return 18
	elseif itemEquipLoc == "INVTYPE_RELIC" then return 18
	elseif itemEquipLoc == "INVTYPE_TABARD" then return -1
	elseif itemEquipLoc == "INVTYPE_BAG" then return 20
	elseif itemEquipLoc == "INVTYPE_QUIVER" then return 20
	else return -1
	end
end

function LootCouncil_Browser.initiateAbort()
	if isInitiator == 1 then
		LootCouncil_Browser.confirmAbort()
	else
		print("Suggesting to "..theInitiator.." that we abort this loot council session")
		SendAddonMessage("L00TCOUNCIL", "suggestAbort", "WHISPER", theInitiator)
	end
end

function LootCouncil_Browser.confirmAbort()
	StaticPopup_Show("LOOT_COUNCIL_CONFIRM_ABORT")
end

function LootCouncil_Browser.closeLootCouncilSession()
	if isInitiator == 1 then
		SendChatMessage("item: "..itemRunning, "OFFICER");
		SendChatMessage("--------------ENDED--------------", "OFFICER");
	end
	LootCouncil_Browser.sendGlobalMessage("abort")
	auctionRunning = 0;
	itemRunning = nil;
	isInitiator = 0;
	theInitiator = "";
	firstTimeThrough = 0;
	sessionMaster = 0;
	theVote = "";
	voteFor = "";
	suggestedBy = "";
	selection = nil;
	councilList = " ";
	councilList = " ";
	councilNum = 1;
	LootCouncil_Browser.Data = {}
	LootCouncil_Browser.Elects = {}
	LootCouncil_Browser.Votes = {}
	LootCouncil_Browser.WhisperList = {}
	LootCouncil_Browser.resetConsideration()
	LootCouncil_Browser.Update()
end

function LootCouncil_Browser.voteDescTooltip(voteStr)
	GameTooltip:SetOwner(MainFrame, "ANCHOR_CURSOR")
	GameTooltip:SetText(voteStr)
	GameTooltip:Show()
end

function LootCouncil_Browser.isValidVoter(name)
	if name == "player" or name == UnitName("player") or name == theInitiator then
		return 1
	else
		for ci = 1, MAX_VOTERS do
			if LootCouncil_Browser.WhisperList[ci] and LootCouncil_Browser.WhisperList[ci] == name then
				return 1
			end
		end
		for ci = 1, GetNumGuildMembers() do
			local theName, rank, rankIndex, level, class, zone, note, officernote, online, status, classFileName = GetGuildRosterInfo(ci);
			if name == theName then
				if rankIndex <= LootCouncil_minRank then
					return 1;
				else
					return 0;
				end
			end
		end
	end
	return 0
end

function LootCouncil_Browser.manualAdd(thePlayer, theItem)
	if isInitiator == 1 and itemRunning then
		LootCouncil_Browser.newEntry(thePlayer, theItem)
	end
	
	if not itemRunning then
		print("There currently is no loot council in session. Start one before adding.");
	elseif isInitiator == 0 then
		print("You must be the initiator in order to manually add someone");
	end
end

function LootCouncil_Browser.RemoveSelection()
	LootCouncil_Browser.sendGlobalMessage("remove "..selection[1]);
	LootCouncil_Browser.removePlayer(selection[1]);
	LootCouncil_Browser.ClearSelection()
	LootCouncil_Browser.Update()
end

function LootCouncil_Browser.removePlayer(playerName)
	if selection and selection[1] == playerName then
		LootCouncil_Browser.ClearSelection()
	end
	local found = 0;
	for ci = 1, (MAX_ENTRIES-1) do -- Loop through all people on the table
		if found == 0 then
			local theEntry = LootCouncil_Browser.Elects[ci]; -- Pull each row
			if theEntry[1] == playerName then
				found=1;
				LootCouncil_Browser.Elects[ci] = LootCouncil_Browser.Elects[ci+1];
			end
		else
			LootCouncil_Browser.Elects[ci] = LootCouncil_Browser.Elects[ci+1];
		end
	end
	
	if (found == 1) then
		LootCouncil_Browser.Elects[MAX_ENTRIES] = nil;
	else
		local theEntry = LootCouncil_Browser.Elects[MAX_ENTRIES]; -- Pull each row
		if theEntry[1] == playerName then
			LootCouncil_Browser.Elects[MAX_ENTRIES] = nil;
		end
	end
	LootCouncil_Browser.Update()
end

function LootCouncil_Browser.getGuildRank(playerName)
	for ci=1, GetNumGuildMembers(true) do
		local name, rank = GetGuildRosterInfo(ci)
		if name == playerName then
			return rank
		end
	end
	
	return "N/A"
end